/*******************************************************************************
 * Copyright (c) 2015-2016, IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Daniel Segesdi, Tamas Borbas, Robert Doczi, Peter Lunk - initial API and implementation
 *******************************************************************************/
package com.incquerylabs.emdw.cpp.common.util

import com.google.common.base.Optional
import com.incquerylabs.emdw.valuedescriptor.ValueDescriptor
import java.util.List
import org.eclipse.uml2.uml.Operation
import org.eclipse.uml2.uml.Type
import org.eclipse.xtend.lib.annotations.Data

@Data
class OperationTypedValueDescriptorPair<Descriptor extends ValueDescriptor> {
	Optional<Operation> operation
	List<UmlTypedValueDescriptor<? extends Descriptor>> typedValueDescriptors
}

@Data
class UmlTypedValueDescriptor<Descriptor extends ValueDescriptor> {
	Type type;
	Descriptor descriptor;
}

@Data
class XtTypedValueDescriptor<Descriptor extends ValueDescriptor> {
	org.eclipse.papyrusrt.xtumlrt.common.Type type;
	Descriptor descriptor;
}