/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor.impl;

import com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor;
import com.incquerylabs.emdw.valuedescriptor.LiteralDescriptor;
import com.incquerylabs.emdw.valuedescriptor.OperationCallDescriptor;
import com.incquerylabs.emdw.valuedescriptor.ParameterDescriptor;
import com.incquerylabs.emdw.valuedescriptor.PropertyAccessDescriptor;
import com.incquerylabs.emdw.valuedescriptor.PropertyReadDescriptor;
import com.incquerylabs.emdw.valuedescriptor.PropertyWriteDescriptor;
import com.incquerylabs.emdw.valuedescriptor.SingleVariableDescriptor;
import com.incquerylabs.emdw.valuedescriptor.ValueDescriptor;
import com.incquerylabs.emdw.valuedescriptor.ValuedescriptorFactory;
import com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage;
import com.incquerylabs.emdw.valuedescriptor.VariableDescriptor;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ValuedescriptorPackageImpl extends EPackageImpl implements ValuedescriptorPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass valueDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass literalDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass operationCallDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass singleVariableDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass collectionVariableDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyAccessDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyReadDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyWriteDescriptorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass parameterDescriptorEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private ValuedescriptorPackageImpl() {
		super(eNS_URI, ValuedescriptorFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link ValuedescriptorPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static ValuedescriptorPackage init() {
		if (isInited) return (ValuedescriptorPackage)EPackage.Registry.INSTANCE.getEPackage(ValuedescriptorPackage.eNS_URI);

		// Obtain or create and register package
		ValuedescriptorPackageImpl theValuedescriptorPackage = (ValuedescriptorPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ValuedescriptorPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new ValuedescriptorPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theValuedescriptorPackage.createPackageContents();

		// Initialize created meta-data
		theValuedescriptorPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theValuedescriptorPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(ValuedescriptorPackage.eNS_URI, theValuedescriptorPackage);
		return theValuedescriptorPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getValueDescriptor() {
		return valueDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getValueDescriptor_BaseType() {
		return (EAttribute)valueDescriptorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getValueDescriptor_TemplateTypes() {
		return (EAttribute)valueDescriptorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getValueDescriptor_FullType() {
		return (EAttribute)valueDescriptorEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getValueDescriptor_StringRepresentation() {
		return (EAttribute)valueDescriptorEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getValueDescriptor_ValueRepresentation() {
		return (EAttribute)valueDescriptorEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getValueDescriptor_PointerRepresentation() {
		return (EAttribute)valueDescriptorEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLiteralDescriptor() {
		return literalDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVariableDescriptor() {
		return variableDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOperationCallDescriptor() {
		return operationCallDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSingleVariableDescriptor() {
		return singleVariableDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCollectionVariableDescriptor() {
		return collectionVariableDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCollectionVariableDescriptor_CollectionNamespace() {
		return (EAttribute)collectionVariableDescriptorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyAccessDescriptor() {
		return propertyAccessDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyReadDescriptor() {
		return propertyReadDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyWriteDescriptor() {
		return propertyWriteDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getParameterDescriptor() {
		return parameterDescriptorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValuedescriptorFactory getValuedescriptorFactory() {
		return (ValuedescriptorFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		valueDescriptorEClass = createEClass(VALUE_DESCRIPTOR);
		createEAttribute(valueDescriptorEClass, VALUE_DESCRIPTOR__BASE_TYPE);
		createEAttribute(valueDescriptorEClass, VALUE_DESCRIPTOR__TEMPLATE_TYPES);
		createEAttribute(valueDescriptorEClass, VALUE_DESCRIPTOR__FULL_TYPE);
		createEAttribute(valueDescriptorEClass, VALUE_DESCRIPTOR__STRING_REPRESENTATION);
		createEAttribute(valueDescriptorEClass, VALUE_DESCRIPTOR__VALUE_REPRESENTATION);
		createEAttribute(valueDescriptorEClass, VALUE_DESCRIPTOR__POINTER_REPRESENTATION);

		literalDescriptorEClass = createEClass(LITERAL_DESCRIPTOR);

		variableDescriptorEClass = createEClass(VARIABLE_DESCRIPTOR);

		operationCallDescriptorEClass = createEClass(OPERATION_CALL_DESCRIPTOR);

		singleVariableDescriptorEClass = createEClass(SINGLE_VARIABLE_DESCRIPTOR);

		collectionVariableDescriptorEClass = createEClass(COLLECTION_VARIABLE_DESCRIPTOR);
		createEAttribute(collectionVariableDescriptorEClass, COLLECTION_VARIABLE_DESCRIPTOR__COLLECTION_NAMESPACE);

		propertyAccessDescriptorEClass = createEClass(PROPERTY_ACCESS_DESCRIPTOR);

		propertyReadDescriptorEClass = createEClass(PROPERTY_READ_DESCRIPTOR);

		propertyWriteDescriptorEClass = createEClass(PROPERTY_WRITE_DESCRIPTOR);

		parameterDescriptorEClass = createEClass(PARAMETER_DESCRIPTOR);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		literalDescriptorEClass.getESuperTypes().add(this.getValueDescriptor());
		variableDescriptorEClass.getESuperTypes().add(this.getValueDescriptor());
		operationCallDescriptorEClass.getESuperTypes().add(this.getValueDescriptor());
		singleVariableDescriptorEClass.getESuperTypes().add(this.getVariableDescriptor());
		collectionVariableDescriptorEClass.getESuperTypes().add(this.getVariableDescriptor());
		propertyAccessDescriptorEClass.getESuperTypes().add(this.getValueDescriptor());
		propertyReadDescriptorEClass.getESuperTypes().add(this.getPropertyAccessDescriptor());
		propertyWriteDescriptorEClass.getESuperTypes().add(this.getPropertyAccessDescriptor());
		parameterDescriptorEClass.getESuperTypes().add(this.getVariableDescriptor());

		// Initialize classes, features, and operations; add parameters
		initEClass(valueDescriptorEClass, ValueDescriptor.class, "ValueDescriptor", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getValueDescriptor_BaseType(), ecorePackage.getEString(), "baseType", null, 1, 1, ValueDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getValueDescriptor_TemplateTypes(), ecorePackage.getEString(), "templateTypes", null, 0, -1, ValueDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getValueDescriptor_FullType(), ecorePackage.getEString(), "fullType", null, 1, 1, ValueDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getValueDescriptor_StringRepresentation(), ecorePackage.getEString(), "stringRepresentation", null, 1, 1, ValueDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getValueDescriptor_ValueRepresentation(), ecorePackage.getEString(), "valueRepresentation", null, 1, 1, ValueDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getValueDescriptor_PointerRepresentation(), ecorePackage.getEString(), "pointerRepresentation", null, 1, 1, ValueDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(literalDescriptorEClass, LiteralDescriptor.class, "LiteralDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(variableDescriptorEClass, VariableDescriptor.class, "VariableDescriptor", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(operationCallDescriptorEClass, OperationCallDescriptor.class, "OperationCallDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(singleVariableDescriptorEClass, SingleVariableDescriptor.class, "SingleVariableDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(collectionVariableDescriptorEClass, CollectionVariableDescriptor.class, "CollectionVariableDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCollectionVariableDescriptor_CollectionNamespace(), ecorePackage.getEString(), "collectionNamespace", null, 0, 1, CollectionVariableDescriptor.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(propertyAccessDescriptorEClass, PropertyAccessDescriptor.class, "PropertyAccessDescriptor", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyReadDescriptorEClass, PropertyReadDescriptor.class, "PropertyReadDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyWriteDescriptorEClass, PropertyWriteDescriptor.class, "PropertyWriteDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(parameterDescriptorEClass, ParameterDescriptor.class, "ParameterDescriptor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} //ValuedescriptorPackageImpl
